module Reg4w2OEs(D3, D2, D1, D0, Clk, Q3, Q2, Q1, Q0, Load, OE1, OE2);
  input		D3;
  input		D2;
  input		D1;
  input		D0;
  input		Clk;
  output	Q3;
  output	Q2;
  output	Q1;
  output	Q0;
  input		Load;
  input		OE1;
  input		OE2;

  reg		Q3, Q2, Q1, Q0;
  reg [3:0]	state;

  always @(posedge Clk) begin
	if (Load) state = {D3, D2, D1, D0};
  end

  assign Q3 = (OE1 | OE2) ? state[3] : 1'bZ;
  assign Q2 = (OE1 | OE2) ? state[2] : 1'bZ;
  assign Q1 = (OE1 | OE2) ? state[1] : 1'bZ;
  assign Q0 = (OE1 | OE2) ? state[0] : 1'bZ;

endmodule
