module S2P(Sin, Sval, D0, D1, D2, D3, LdChk, Ld4, Ld3, Ld2, Ld1, Clk, Reset);
  input		Sin;
  input		Sval;
  output	D0;
  output	D1;
  output	D2;
  output	D3;
  output	LdChk;
  output	Ld4;
  output	Ld3;
  output	Ld2;
  output	Ld1;
  input		Clk;
  input		Reset;

  reg		D0, D1, D2, D3;
  reg		Ld1, Ld2, Ld3, Ld4, LdChk;

  /* Internals */
  reg[3:0] 	data; 
  reg[4:0] 	count; 

  /* Count and shift-register flip-flops including reset */
  always @(posedge Clk) begin 
	if (Reset) begin
		count = 0; 
	end 
	else begin 
		if (Sval) begin
			data  = {data[2:0], Sin}; 
			count = count + 1;
		end
		else begin
			if (count == 20) count = 0;
		end
	end 
  end 

  /* Output of shift register */
  assign D3 = data[3];
  assign D2 = data[2];
  assign D1 = data[1];
  assign D0 = data[0];

  /* Output logic based on value of count */
  assign Ld1   = (count == 4); 
  assign Ld2   = (count == 8); 
  assign Ld3   = (count == 12); 
  assign Ld4   = (count == 16); 
  assign LdChk = (count == 20); 

endmodule
